#include <config.h>
#include <ChiliAudioChannel.h>
#include <ChiliProject.h>
#include <ChiliSession.h>
#include <FL/fl_ask.H>
#include <string>
#include <algorithm>

ChiliAudioChannel::ChiliAudioChannel(ChiliProject * p_proj,const unsigned int p_channelnum) {
	lasterror=SUCCESS;
	channelnum=MAXCHANNELS;
	project=NULL;
	rawfilename=NULL;
	if (p_proj==NULL) {
		lasterror=ERROR_PROJECT_OBLIGATORY;
		return;
	}
	if (p_channelnum>=MAXCHANNELS) {
		lasterror=ERROR_INVALID_CHANNEL;
		return;
	}
	project=p_proj;
	channelnum=p_channelnum;

}

ChiliAudioChannel::~ChiliAudioChannel() {
	// Do any cleaning up for the channel
	// -removing temporary files
	// -free memory for filename
	if (rawfilename!=NULL) {
		remove(rawfilename);
		free (rawfilename);
	}
}

unsigned int ChiliAudioChannel::LinkToRawFile(const char * strFileName) {
	if (strFileName==NULL) {
		return ERROR_FILENAME_OBLIGATORY;
	}
	rawfilename=(char *)malloc(strlen(strFileName)+1);
	if (rawfilename==NULL) {
		return ERROR_MEMORY_FULL;
	}
	rawfilename[0]='\0';
	strcpy(rawfilename,strFileName);
	return SUCCESS;
}

